package db

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_day_luck_draw.git/db/model"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_day_luck_draw.git/md"
	zhios_day_luck_draw_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_day_luck_draw.git/utils"
	"errors"
	"time"
	"xorm.io/xorm"
)

func AddOrderJackpot(eg *xorm.Engine, req md.DayLuckDrawOrderJackpotReq) error {
	count, _ := eg.Where("oid=? and uid=? and pvd=?", req.Oid, req.Uid, req.Pvd).Count(&model.DayLuckDrawOrderJackpot{})
	if count > 0 {
		return nil
	}
	var data = &model.DayLuckDrawOrderJackpot{
		Oid:        req.Oid,
		Pvd:        req.Pvd,
		Amount:     req.Amount,
		Commission: req.Commission,
		Reward:     req.Reward,
		Uid:        zhios_day_luck_draw_utils.StrToInt(req.Uid),
		CreateTime: time.Now(),
	}
	one, err := eg.InsertOne(data)
	if one == 0 {
		return errors.New("失败")
	}
	if err != nil {
		return err
	}
	return nil
}

/***
1.创建期数
2.获取还没分配的金额 就是 期数为0的
3.把期数设置到订单
4.查出所有订单号
5.随机出订单号（每个名额随机一次 如果重复再次循环） 先按一等奖分
*/

func GetAllOrderSum(sess *xorm.Session) float64 {
	sum, _ := sess.Where("period=0").Sum(&model.DayLuckDrawOrderJackpot{}, "reward")
	return sum
}
func GetAllOrderOid(sess *xorm.Session) []string {
	sql := `SELECT oid,uid FROM day_luck_draw_order_jackpot where period=0;`
	data, _ := QueryNativeStringSess(sess, sql)
	var list = make([]string, 0)
	if len(data) > 0 {
		for _, v := range data {
			list = append(list, v["uid"])
		}
	}
	return list
}
